classdef FindAndReplace < handle
    %FINDANDREPLACE Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        daEditor
        figH = []; % find figure
    end
    properties (Access = private)
        found = []; % nx2 [start Found, end Found]
        tokens = {}; % regexp tokens
        curFoundPos = 0; % fr find next prev relevant
        
        regExp = ''; % to find
        iCase = ''; % matchCase ?
    end 
    
    methods 
        function obj = FindAndReplace(daEditor)
            obj.daEditor = daEditor;
        end
        
        function resetCurFindPos(obj,src,evnt)
            obj.curFoundPos = 0;
        end
        
        function resetSearchStr(obj)
            if ~isempty(obj.figH)
                try
                    setappdata(obj.figH,'searchStr',  '');
                catch
                    warning('ka wieso der da rein ist');
                    obj.figH = [];
                end
            end
        end
            
    end
    
    methods (Static, Hidden = true)
        function [searchS,searchE] = getSearchPos(obj)
            searchS = 1; searchE = numel(obj.daEditor.getText);
            
            chb_sect  = get(getappdata(obj.figH,'chb_sect'),'Value');
            chb_sel   = get(getappdata(obj.figH,'chb_sel'), 'Value');
            
            %----- Checkbox - Current Section -----
            if chb_sect
                [searchS,searchE] = obj.daEditor.getSectionPosByLine(obj.daEditor.selection(1));
            end
            %----- Checkbox - In Selection -----
            if chb_sel
                sel = obj.daEditor.selection;
                searchS = obj.daEditor.idx2pos(sel(1),sel(2));
                searchE = obj.daEditor.idx2pos(sel(3),sel(4));
            end
        end
        
        function findText(obj)
            txt = obj.daEditor.getText;
            chb_regex = get(getappdata(obj.figH,'chb_regex'),'Value');
            chb_beg   = get(getappdata(obj.figH,'chb_beg'),'Value');
            chb_end   = get(getappdata(obj.figH,'chb_end'),'Value');
            chb_case  = get(getappdata(obj.figH,'chb_case'),'Value');
            chb_word  = get(getappdata(obj.figH,'chb_word'),'Value');
            edt_find  = get(getappdata(obj.figH,'edt_find'),'string');
           
            prfx = '';sfx = '';
            [searchS,searchE] = obj.getSearchPos(obj);
            %----- Checkbox - Entire, Beginning und End Word-----
            if chb_word || chb_beg
                prfx = '\<'; 
            end
            if chb_word || chb_end
                sfx = '\>';
            end
            
            %----- Checkbox - Match Case -----
            if chb_case
                iCase = 'matchcase';
            else
                iCase = 'ignorecase';
            end
            %----- Checkbox - regex -----
            if ~chb_regex
                edt_find = regexprep(edt_find,'([\.*+(){}\[\]$])','\\$1');
%                 sfx = ['?=(\s)',sfx];
            end
            obj.regExp = edt_find;
            obj.iCase = iCase;
            %----- Suchen -----
            [s,e,m,t] = regexp(txt(searchS:searchE),[prfx,edt_find,sfx],'start','end','match','tokens',iCase);
            if isempty(s)
                obj.found = [];
                return %nichts gefunden
            end
            posS = s+searchS-1; % falls Selection oder Section angewhlt wurden
            posE = e+searchS-1;
            
            obj.found = [posS(:),posE(:)];
            obj.tokens = t(:);
        end
        %% ----- Callbacks -----
        function pushbutton_findNextPrev_Callback(obj, src,evnt,nextORprev)
            % 0 == previos
            % 1 == next
            f = 0;
            edt_find = get(getappdata(obj.figH,'edt_find'),'string');
            
            hilfExp = ceil(log10(size(obj.found,1)));
            hilfAnz = 37 + 3*hilfExp + numel(edt_find);
            if isinf(hilfAnz) || isnan(hilfAnz);    hilfAnz = 0;    end
            if isinf(hilfExp) || isnan(hilfExp);    hilfExp = 1;    end
            if ~strcmp(edt_find,getappdata(obj.figH,'searchStr')) || isempty(obj.found)
                obj.findText(obj);
                setappdata(obj.figH,'searchStr',  edt_find);
            end
            
            if ~isempty(obj.found)
                if nextORprev
                    obj.curFoundPos = obj.curFoundPos + 1; % next
                    if obj.curFoundPos > size(obj.found,1)
                        obj.curFoundPos = 1;
                    end
                else
                    obj.curFoundPos = obj.curFoundPos - 1; % previous
                    if obj.curFoundPos < 1
                        obj.curFoundPos = size(obj.found,1);
                    end
                end
                [sR,sC] = obj.daEditor.pos2idx(obj.found(obj.curFoundPos,1));
                [eR,eC] = obj.daEditor.pos2idx(obj.found(obj.curFoundPos,2));
                obj.daEditor.selectLinCol(sR,sC,eR,eC+1);
                f = obj.curFoundPos;
            end
            
            fprintf(repmat('\b',1,hilfAnz));
            txt = sprintf('expression "%%s" is %%%1$sg times found (%%%1$sg of %%%1$sg)\n',num2str(hilfExp));
            fprintf(txt,edt_find,size(obj.found,1),f,size(obj.found,1));
        end
        function closeRequestFcn(obj,src,evnt)
            delete(obj.figH);
            obj.figH = [];
        end
        %----- keypress events -----
        function keyPressEvent(obj,src,evnt)
            switch evnt.Key
                case 'escape' % soll das fenster schlieen
                    close(src)
                otherwise
            end
        end
        function keyPressEvent_edt_find(obj,src,evnt)
            switch evnt.Key
                case 'return' % soll das fenster schlieen
                    if ~isempty(evnt.Modifier) && strcmp(evnt.Modifier{1},'shift')
                        daEditor.FindAndReplace.pushbutton_findNextPrev_Callback(obj,src,evnt,0)
                    else
                        daEditor.FindAndReplace.pushbutton_findNextPrev_Callback(obj,src,evnt,1)
                    end
                otherwise
                    obj.findText(obj);
            end
        end
        %------ checkboxes callbacks -----
        function chb_toggleState(obj,src,evnt)
            if get(src,'value') % nur wenn ein hkchen gesetzt wurde sonst ist es egal
                if strcmp(get(src,'tag'),'checkbox_inCurrentSection')
                    set(findall(get(obj.figH,'children'),'tag','checkbox_currentSelection'),'value',false);
                else
                    set(findall(get(obj.figH,'children'),'tag','checkbox_inCurrentSection'),'value',false);
                end
            end
            
            obj.resetSearchStr();
        end
        %----- Replace Functions -----
        function pushbutton_replace_Callback(obj,src,evnt)
            if isempty(obj.found);  obj.findText(obj); end
            if isempty(obj.found);  fprintf('nothing found to replace\n'); return; end
            rep = obj.getRepStr(obj);
            
            posS = obj.found(obj.curFoundPos,1);
            posE = obj.found(obj.curFoundPos,2);
            obj.daEditor.repText(rep,posS-1,posE);
            
            obj.repairFoundPos(obj,rep,posS,posE);
            
            obj.found(obj.curFoundPos,:) = [];
            obj.curFoundPos = obj.curFoundPos - 1;
            daEditor.FindAndReplace.pushbutton_findNextPrev_Callback(obj, src,evnt,1);
        end
        function pushbutton_replaceAll_Callback(obj,src,evnt)
            if isempty(obj.found);  obj.findText(obj); end
            if isempty(obj.found);  fprintf('nothing found to replace\n'); return; end
            
            curPos = obj.daEditor.selectionPos(1);
            edt_repl = get(getappdata(obj.figH,'edt_repl'),'string');
            
            txt = obj.daEditor.getText;
            [searchS,searchE] = obj.getSearchPos(obj);
            if get(getappdata(obj.figH,'chb_sel'), 'Value') && diff([searchS,searchE]) == 0
                 fprintf('nothing found to replace\n'); return; 
            end
            txt_ = regexprep(txt(searchS:searchE),obj.regExp, edt_repl,obj.iCase);
            txt(searchS:searchE) = '';
            if isempty(txt)
                txt = txt_;
            else
                txt = [txt(1:searchS-1),txt_,txt(searchS:end)];
            end
            obj.daEditor.setText(txt);
            obj.daEditor.goToPos(curPos);
        end
        %----- Hilfs funktionen -----
        function repairFoundPos(obj,repStr,posS,posE)
            idx = obj.found > posS;
            obj.found(idx) = obj.found(idx) + numel(repStr) - (posE - (posS - 1));
        end
        function rep = getRepStr(obj)
            rep = get(getappdata(obj.figH,'edt_repl'),'string');
            expr = get(getappdata(obj.figH,'edt_find'),'string');
            
            posS = obj.found(obj.curFoundPos,1);
            posE = obj.found(obj.curFoundPos,2);
            txt = obj.daEditor.getText(posS,posE);
            
            rep = regexprep(txt,expr,rep);
        end
    end
    
    methods (Static)
        function openGUI(daEdit)
            obj = daEdit.findAndReplace;
            
            if ~isempty(obj.figH)
                try
                    set(obj.figH,'visible','on'); 
                    % falls es das figure doch nicht gibt soll HIER kein neues geffnet werden.
                    figureDA(obj.figH); % bringt das figure in den vordergrund
                    return
                catch ignored
                end
            end
            
            obj.figH = figureDA('name','FindAndReplace','numbertitle','off','menubar','none');
            set(obj.figH,'WindowKeyPressFcn',@(src,evnt)daEditor.FindAndReplace.keyPressEvent(obj,src,evnt),...
                         'CloseRequestFcn',@(src,evnt)daEditor.FindAndReplace.closeRequestFcn(obj,src,evnt));
            
            bgcol = get(obj.figH,'color');
            fig_pos = get(obj.figH,'position');
            set(obj.figH,'position',[fig_pos(1:2),350,150]);
            set(obj.figH,'Units','normalized');
            
            %----- UI Find -----
            edt_find = uicontrol('style','edit','units','normalized','Position',[0.15,0.80,0.5,0.18],'tag','edit_find',...
                'callback',@(src,evnt)resetCurFindPos(obj,src,evnt),'KeyPressFcn',@(src,evnt)daEditor.FindAndReplace.keyPressEvent_edt_find(obj,src,evnt),...
                'TooltipString','<html><b>Enter</b> Find Next<br><b>Shift Enter</b> Find Previous</html>','backgroundcolor',[1,1,1]);
            
            txt_find = uicontrol('style','text','units','normalized','Position',[0.01,0.83,0.13,0.10],'tag','text_find',...
                'string','find','backgroundcolor',bgcol); %#ok<NASGU>
            edt_repl = uicontrol('style','edit','units','normalized','Position',[0.15,0.60,0.5,0.18],'tag','edit_repl',...
                'backgroundcolor',[1,1,1]);
            
            txt_repl = uicontrol('style','text','units','normalized','Position',[0.01,0.63,0.13,0.10],'tag','text_repl',...
                'string','Replace','backgroundcolor',bgcol); %#ok<NASGU>
            
            
            %----- UI Checkboxes -----
            chb_regex = uicontrol('style','checkbox','units','normalized','Position',[0.05,0.42,0.25,0.18],...
                'tag','checkbox_regex','string','useregex','backgroundcolor',bgcol,'value',1,...
                'callback',@(src,evnt)daEditor.FindAndReplace.chb_toggleState(obj,src,evnt));
            chb_beg = uicontrol('style','checkbox','units','normalized','Position',[0.05,0.28,0.25,0.18],...
                'tag','checkbox_beginningWord','string','Beg. of Word','backgroundcolor',bgcol,...
                'callback',@(src,evnt)daEditor.FindAndReplace.chb_toggleState(obj,src,evnt));
            chb_end = uicontrol('style','checkbox','units','normalized','Position',[0.35,0.28,0.25,0.18],...
                'tag','checkbox_endWord','string','End of Word','backgroundcolor',bgcol,...
                'callback',@(src,evnt)daEditor.FindAndReplace.chb_toggleState(obj,src,evnt));
            
            chb_case = uicontrol('style','checkbox','units','normalized','Position',[0.05,0.14,0.25,0.18],...
                'tag','checkbox_case','string','Match case','backgroundcolor',bgcol,...
                'callback',@(src,evnt)daEditor.FindAndReplace.chb_toggleState(obj,src,evnt));
            chb_word = uicontrol('style','checkbox','units','normalized','Position',[0.35,0.14,0.25,0.18],...
                'tag','checkbox_wholeword','string','Whole word','backgroundcolor',bgcol,...
                'callback',@(src,evnt)daEditor.FindAndReplace.chb_toggleState(obj,src,evnt));
            
            chb_sect = uicontrol('style','checkbox','units','normalized','Position',[0.05,0.01,0.30,0.18],...
                'tag','checkbox_inCurrentSection','string','CurrentSection','backgroundcolor',bgcol,...
                'callback',@(src,evnt)daEditor.FindAndReplace.chb_toggleState(obj,src,evnt));
            chb_sel = uicontrol('style','checkbox','units','normalized','Position',[0.35,0.01,0.30,0.18],...
                'tag','checkbox_currentSelection','string','Current Selection','backgroundcolor',bgcol,...
                'callback',@(src,evnt)daEditor.FindAndReplace.chb_toggleState(obj,src,evnt));
            
            %----- Appdaten Setzen -----
            setappdata(obj.figH,'edt_find',   edt_find);
            setappdata(obj.figH,'edt_repl',   edt_repl);
            setappdata(obj.figH,'chb_regex',  chb_regex);
            setappdata(obj.figH,'chb_beg',    chb_beg);
            setappdata(obj.figH,'chb_end',    chb_end);
            setappdata(obj.figH,'chb_case',   chb_case);
            setappdata(obj.figH,'chb_word',   chb_word);
            setappdata(obj.figH,'chb_sect',   chb_sect);
            setappdata(obj.figH,'chb_sel',    chb_sel);
            setappdata(obj.figH,'daEditor',   daEdit);
            setappdata(obj.figH,'searchStr',  '');
            
            %----- UI Pushbuttons appdata -----
            psh_findNext = uicontrol('style','pushbutton','units','normalized','Position',[0.70,0.80,0.25,0.18],...
                'tag','pushbutton_findNext','string','Find Next','callback',@(src,evnt)daEditor.FindAndReplace.pushbutton_findNextPrev_Callback(obj,src,evnt,1)); %#ok<NASGU>
            psh_findPrev = uicontrol('style','pushbutton','units','normalized','Position',[0.70,0.60,0.25,0.18],...
                'tag','pushbutton_findPrev','string','Find Previous','callback',@(src,evnt)daEditor.FindAndReplace.pushbutton_findNextPrev_Callback(obj,src,evnt,0)); %#ok<NASGU>
            psh_repl = uicontrol('style','pushbutton','units','normalized','Position',[0.70,0.35,0.25,0.18],...
                'tag','pushbutton_replace','string','Replace','callback',@(src,evnt)daEditor.FindAndReplace.pushbutton_replace_Callback(obj,src,evnt)); %#ok<NASGU>
            psh_replAll = uicontrol('style','pushbutton','units','normalized','Position',[0.70,0.15,0.25,0.18],...
                'tag','pushbutton_replaceAll','string','Replace All','callback',@(src,evnt)daEditor.FindAndReplace.pushbutton_replaceAll_Callback(obj,src,evnt)); %#ok<NASGU>
        end
    end
    
end

