classdef ColorExcel07 < int32 & enumDA.EnumExtensions

% See also Excel 2007 standard Color palette
    enumeration
    % 1st Row
        r1c01_White             (hex2dec(grafik.Color.valueOfRGB255(255,255,255).toHex))
        r1c02_Black             (hex2dec(grafik.Color.valueOfRGB255(  0,  0,  0).toHex))
        r1c03_Brown             (hex2dec(grafik.Color.valueOfRGB255(238,236,225).toHex))
        r1c04_DarkBlue          (hex2dec(grafik.Color.valueOfRGB255( 31, 73,125).toHex))
        r1c05_Blue              (hex2dec(grafik.Color.valueOfRGB255( 79,129,189).toHex))
        r1c06_Red               (hex2dec(grafik.Color.valueOfRGB255(192, 80, 77).toHex))
        r1c07_Green             (hex2dec(grafik.Color.valueOfRGB255(155,187, 89).toHex))
        r1c08_Violet            (hex2dec(grafik.Color.valueOfRGB255(128,100,162).toHex))
        r1c09_Cyan              (hex2dec(grafik.Color.valueOfRGB255( 75,172,198).toHex))
        r1c10_Orange            (hex2dec(grafik.Color.valueOfRGB255(247,150, 70).toHex))
    % 1st Column: Gray Colors in percent
        r2c1_Gray5              (hex2dec(grafik.Color.valueOfRGB255(242).toHex))
        r3c1_Gray15             (hex2dec(grafik.Color.valueOfRGB255(216).toHex))
        r4c1_Gray25             (hex2dec(grafik.Color.valueOfRGB255(191).toHex))
        r5c1_Gray35             (hex2dec(grafik.Color.valueOfRGB255(165).toHex))
        r6c1_Gray50             (hex2dec(grafik.Color.valueOfRGB255(127).toHex))
    % 2cd Column: Gray Colors in percent
        r2c2_Gray50             (hex2dec(grafik.Color.valueOfRGB255(128).toHex))
        r3c2_Gray65             (hex2dec(grafik.Color.valueOfRGB255( 90).toHex))
        r4c2_Gray75             (hex2dec(grafik.Color.valueOfRGB255( 64).toHex))
        r5c2_Gray85             (hex2dec(grafik.Color.valueOfRGB255( 39).toHex))
        r6c2_Gray95             (hex2dec(grafik.Color.valueOfRGB255( 13).toHex))
    % 3rd Column: Brown
        r2c3_Brown              (hex2dec(grafik.Color.valueOfRGB255(221,217,195).toHex))
        r3c3_Brown              (hex2dec(grafik.Color.valueOfRGB255(197,190,151).toHex))
        r4c3_Brown              (hex2dec(grafik.Color.valueOfRGB255(148,139, 84).toHex))
        r5c3_Brown              (hex2dec(grafik.Color.valueOfRGB255( 74, 69, 42).toHex))
        r6c3_Brown              (hex2dec(grafik.Color.valueOfRGB255( 29, 27, 17).toHex))
    % 4th Column: DarkBlue
        r2c4_DarkBlue           (hex2dec(grafik.Color.valueOfRGB255(197,217,241).toHex))
        r3c4_DarkBlue           (hex2dec(grafik.Color.valueOfRGB255(141,180,227).toHex))
        r4c4_DarkBlue           (hex2dec(grafik.Color.valueOfRGB255( 83,142,213).toHex))
        r5c4_DarkBlue           (hex2dec(grafik.Color.valueOfRGB255( 23, 55, 93).toHex))
        r6c4_DarkBlue           (hex2dec(grafik.Color.valueOfRGB255( 15, 37, 63).toHex))
    % 5th Column: Blue
        r2c5_Blue               (hex2dec(grafik.Color.valueOfRGB255(219,229,241).toHex))
        r3c5_Blue               (hex2dec(grafik.Color.valueOfRGB255(184,204,228).toHex))
        r4c5_Blue               (hex2dec(grafik.Color.valueOfRGB255(149,179,215).toHex))
        r5c5_Blue               (hex2dec(grafik.Color.valueOfRGB255( 55, 96,145).toHex))
        r6c5_Blue               (hex2dec(grafik.Color.valueOfRGB255( 37, 64, 97).toHex))
    % 6th Column: Red
        r2c6_Red                (hex2dec(grafik.Color.valueOfRGB255(242,221,220).toHex))
        r3c6_Red                (hex2dec(grafik.Color.valueOfRGB255(230,185,184).toHex))
        r4c6_Red                (hex2dec(grafik.Color.valueOfRGB255(217,151,149).toHex))
        r5c6_Red                (hex2dec(grafik.Color.valueOfRGB255(149, 55, 53).toHex))
        r6c6_Red                (hex2dec(grafik.Color.valueOfRGB255( 99, 37, 35).toHex))
    % 7th Column: Green
        r2c7_Green              (hex2dec(grafik.Color.valueOfRGB255(234,241,221).toHex))
        r3c7_Green              (hex2dec(grafik.Color.valueOfRGB255(215,228,188).toHex))
        r4c7_Green              (hex2dec(grafik.Color.valueOfRGB255(194,214,154).toHex))
        r5c7_Green              (hex2dec(grafik.Color.valueOfRGB255(117,146, 60).toHex))
        r6c7_Green              (hex2dec(grafik.Color.valueOfRGB255( 79, 98, 40).toHex))
    % 8th Column: Violet
        r2c8_Violet             (hex2dec(grafik.Color.valueOfRGB255(229,224,236).toHex))
        r3c8_Violet             (hex2dec(grafik.Color.valueOfRGB255(204,192,218).toHex))
        r4c8_Violet             (hex2dec(grafik.Color.valueOfRGB255(178,161,199).toHex))
        r5c8_Violet             (hex2dec(grafik.Color.valueOfRGB255( 96, 73,123).toHex))
        r6c8_Violet             (hex2dec(grafik.Color.valueOfRGB255( 63, 49, 81).toHex))
    % 9th Column: Cyan
        r2c9_Cyan               (hex2dec(grafik.Color.valueOfRGB255(219,238,243).toHex))
        r3c9_Cyan               (hex2dec(grafik.Color.valueOfRGB255(182,221,232).toHex))
        r4c9_Cyan               (hex2dec(grafik.Color.valueOfRGB255(147,205,221).toHex))
        r5c9_Cyan               (hex2dec(grafik.Color.valueOfRGB255( 49,132,155).toHex))
        r6c9_Cyan               (hex2dec(grafik.Color.valueOfRGB255( 33, 88,103).toHex))
    % 10th Column: Orange
        r2c10_Orange            (hex2dec(grafik.Color.valueOfRGB255(253,233,217).toHex))
        r3c10_Orange            (hex2dec(grafik.Color.valueOfRGB255(252,213,180).toHex))
        r4c10_Orange            (hex2dec(grafik.Color.valueOfRGB255(250,192,144).toHex))
        r5c10_Orange            (hex2dec(grafik.Color.valueOfRGB255(228,109, 10).toHex))
        r6c10_Orange            (hex2dec(grafik.Color.valueOfRGB255(151, 72,  7).toHex))
    % 7th Row
        r7c1_Brown              (hex2dec(grafik.Color.valueOfRGB255(192,  0,  0).toHex))
        r7c2_Red                (hex2dec(grafik.Color.valueOfRGB255(255,  0,  0).toHex))
        r7c3_Orange             (hex2dec(grafik.Color.valueOfRGB255(255,192,  0).toHex))
        r7c4_Yellow             (hex2dec(grafik.Color.valueOfRGB255(255,255,  0).toHex))
        r7c5_YellowGreen        (hex2dec(grafik.Color.valueOfRGB255(146,208, 80).toHex))
        r7c6_BluishGreen        (hex2dec(grafik.Color.valueOfRGB255(  0,176, 80).toHex))
        r7c7_Blue               (hex2dec(grafik.Color.valueOfRGB255(  0,176,240).toHex))
        r7c8_DarkBlue           (hex2dec(grafik.Color.valueOfRGB255(  0,112,192).toHex))
        r7c9_DarkViolet         (hex2dec(grafik.Color.valueOfRGB255(  0, 32, 96).toHex))
        r7c10_Violet            (hex2dec(grafik.Color.valueOfRGB255(112, 48,160).toHex))
    end
    
    methods 
        function color = toColor(obj)
            color = grafik.Color.valueOfHex(dec2hex(obj.uint32));
        end
    end
    methods (Static)
        function enObj = valueOfHex(val)
            % konvertiert die Zahl val in eine Enumeration
            val = hex2dec(val);
            enObj = enumDA.getEnumOfNumber(mfilename('class'), val);
        end
        %% implemetation of abstract methods
        function enObj = valueOfNumber(val)
            % konvertiert die Zahl val in eine Enumeration
            enObj = enumDA.getEnumOfNumber(mfilename('class'), val);
        end
        function enObj = valueOfText(text)
            % konvertiert die Zahl val in eine Enumeration
            enObj = enumDA.getEnumOfText(mfilename('class'), text);
        end
        function enObj = valueOf(valOrText)
            % konvertiert den Wert oder Text auf das entsprechende Enumeration Object
            enObj = enumDA.getEnum(mfilename('class'), valOrText);
        end
    end
end

