function varargout = MESR_GUI(varargin)
% MESR_GUI MATLAB code for MESR_GUI.fig
%      MESR_GUI, by itself, creates a new MESR_GUI or raises the existing
%      singleton*.
%
%      H = MESR_GUI returns the handle to a new MESR_GUI or the handle to
%      the existing singleton*.
%
%      MESR_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MESR_GUI.M with the given input arguments.
%
%      MESR_GUI('Property','Value',...) creates a new MESR_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before MESR_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to MESR_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help MESR_GUI

% Last Modified by GUIDE v2.5 10-Oct-2014 08:32:41

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @MESR_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @MESR_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before MESR_GUI is made visible.
function MESR_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to MESR_GUI (see VARARGIN)

% Choose default command line output for MESR_GUI
grafik.figureGuard(hObject,1)
handles.output = hObject;
% Update handles structure
path2Replacements = getappdata(0,'fileExchangeJustin_repPath');
handles.mesrPath = fullfile(path2Replacements);
guidata(hObject, handles);

fillTable(handles);

handles = guidata(hObject);
set(handles.popupmenu_category,'String',[{'Alles'},handles.uTags]);

% UIWAIT makes MESR_GUI wait for user response (see UIRESUME)
% uiwait(handles.figure_MESR_GUI);
eRegSearch = findjobj(handles.edit_regexp);
set(eRegSearch,'mouseClickedCallback',@(src,evnt) edit_regexp_MouseClickedCallback(src,evnt,handles));
grafik.figureGuard(hObject,0)

% --- Outputs from this function are returned to the command line.
function varargout = MESR_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%% Callbacks
function edit_regexp_MouseClickedCallback(src,evnt,handles)
    refresh(handles.figure_MESR_GUI)
    if strcmp(src.getText,'Suchen (regexp)')
        set(handles.edit_regexp,'String','');
    else
%         set(handles.edit_regexp,'String','Suchen (regexp)');
    end

function pushbutton_insertAndClose_Callback(hObject, eventdata, handles) %#ok<DEFNU>
    pushbutton_insert_Callback(hObject, eventdata, handles)
    pushbutton_close_Callback(hObject, eventdata, handles)
    
function pushbutton_insert_Callback(hObject, eventdata, handles)
    dE = daEditor.DaEditor();
    actions = getSelectedActions(handles);
    
    newText = '';
    for ii = 1:numel(actions)
        action = ['%',actions{ii},'%'];
        newText = sprintf('%s%s\n',newText,Matlab_extendEditorFunctionality_StringReplacements(action));
    end

    dE.repText(newText,dE.selectionPos(1)-1,dE.selectionPos(2)-1)
function pushbutton_close_Callback(hObject, eventdata, handles)
    delete(handles.figure_MESR_GUI);
    
function pushbutton_edit_Callback(hObject, eventdata, handles) %#ok<DEFNU>
    idx = getSelection(handles);
    
    fileNames = getFilenameOfSelection(handles);
    for ii = 1:numel(fileNames)
        edit(fileNames(ii).getLink);
    end
    
function uitable_MESR_CellSelectionCallback(hObject, eventdata, handles) %#ok<DEFNU>
    handles.selectedLine = eventdata.Indices(:,1);
    guidata(handles.figure_MESR_GUI, handles);

function edit_regexp_Callback(hObject, eventdata, handles) %#ok<DEFNU>
    data = handles.data;
    expr = get(handles.edit_regexp,'string');
    if ~isempty(expr)
        idx = util.SearchCell(data,expr,true,false,true);
        if any(any(idx))
            idx = idx(:,1) | idx(:,2);
            data = data(idx,:);
        end
    end
    set(handles.uitable_MESR,'data',data);
    
%% >|| Functions
function fillTable(handles,newFlag)
    if nargin < 2 || isempty(newFlag); newFlag = true; end
    wasOne = false;
    
    set(handles.figure_MESR_GUI,'Visible','on');
    uit = guiElements.UITable(handles.uitable_MESR);
    
    if newFlag
        mesrList = getMESRList(handles);
        handles.catIdx = true(size(mesrList));
    else
        mesrList = handles.mesrList;
    end
    
    idx = handles.catIdx;
    if sum(idx) == 1
        wasOne = true;
        idx = [true;idx]; 
        mesrList = [{''};mesrList]; % sonst funktionier autosize nicht!
    end
    set(uit.uit,'data',mesrList(idx)); % muss hier kurz gemacht werden damit die zeile darunter geht, wills jetzt nicht redesignen
    
    if newFlag
        [mesrDesc,tags,uTags] = getMESRDesc(handles,mesrList);
    else
        mesrDesc = handles.mesrDesc;
        tags = handles.tags;
        uTags = handles.uTags;
    end
    
    if wasOne; mesrDesc = [{''};mesrDesc]; end
    set(uit.uit,'data',[mesrList(idx),mesrDesc(idx)]);
    
    if wasOne
        mesrList(1) = [];
        mesrDesc(1) = [];
    end
    handles.data = [mesrList,mesrDesc];
    handles.mesrDesc = mesrDesc;
    handles.mesrList = mesrList;
    handles.tags = tags;
    handles.uTags = uTags;
    
    pause(0.2);
    drawnow;
    uit.UITAutoColsize;
    
    guidata(handles.figure_MESR_GUI,handles);

function mesrList = getMESRList(handles)    
%     mesrPath = file.Filename(mesrPath)
%     mesrPath.findFileNames('.*')
    oCD = cd(handles.mesrPath);
    dirCont = dir('MESRC_*.m');
    mesrList = {dirCont.name};
    mesrList = mesrList(:);
    
    mesrList = regexprep(mesrList,'MESRC_(.*?)\.m','$1');
    cd(oCD);
    
function [mesrDesc, tags, uTags] = getMESRDesc(handles,mesrList)
    fileNames = getFilenameOfSelection(handles,1:numel(mesrList));
    mesrDesc = repmat({''},size(mesrList));
    uTags = {};
    
    for ii = 1:numel(fileNames)
        jFile = java.io.File(fileNames(ii).getLink);
        jScanner = java.util.Scanner(jFile);
        jScanner.useDelimiter('\n');
        
        txt = '';
        while jScanner.hasNext
            scanned = char(jScanner.next);
            txt = sprintf('%s',txt, scanned);
            
            if ~isempty(regexp(scanned,'%%\s+MESRCEND\s*','once')); 
                break; 
            end
        end
        
        jScanner.close();
        
        [idxS, idxE] = regexp(txt,'(%%\s+MESRCBEGIN|%%\s+MESRCEND\s*)','start','end');
        if ~isempty(idxS)
            txt = txt(idxS(1):idxE(2));
            t = regexp(txt,['(?<!%)%(?=\s)([^\n',char(13),']+)'],'tokens','once');
            mesrDesc{ii} = regexprep(t{:},'^\s','');
            
            t = regexp(txt,['(?<!%)%(?=\s*)\s*Tags:\s*([^\n',char(13),']+)'],'tokens','once');
       
            if ~isempty(t)
                t = regexprep(t,'\s*$','');
                tags(ii,1) = t;
                tags_ = regexp(t{:},',\s*','split');
                uTags = [uTags, tags_];
                [~, idx] = unique(lower(uTags));
                uTags = uTags(idx);
            else
                tags(ii,1) = {''};
            end
        end
    end
    
function idx = getSelection(handles)
    idx = handles.selectedLine;
    
function fileNames = getFilenameOfSelection(handles,idx)
    if nargin < 2; idx = [];    end
    actions = getSelectedActions(handles,idx);
    
    fileName = regexprep(actions,'(.*)',[regexprep(handles.mesrPath,'[\\]','\\\\'),'\\MESRC_$1\.m']);
    for ii = 1:numel(fileName)
        fileNames(ii) = file.Filename(fileName{ii});
    end
    
function actions = getSelectedActions(handles,overwriteSelectionIdx)
    if nargin == 1 || isempty(overwriteSelectionIdx)
        overwriteSelectionIdx = getSelection(handles);
    end
    
    data = get(handles.uitable_MESR,'Data');
    actions = data(overwriteSelectionIdx,1);

%% --|| Callbacks
function pushbutton_new_Callback(hObject, eventdata, handles)
    prompt = {'Enter Command Name (Case Insensitive):'};
    dlg_title = 'New Command';
    num_lines = 1;
    def = {''};
    command = inputdlg(prompt,dlg_title,num_lines,def);
    command = command{1};
    if isempty(command); errordlg('Empty Command'); return; end
    f = file.Filename([SDS_ToolPath_DA,'\MatlabM\Tools\Matlab_Editor_StringReplacements\Replacements\'],...
        ['MESRC_',command],'.m');
    if f.exist; errordlg('Command already exists');  return; end
    fid = fopen(f.getLink,'wt');
    
    fprintf(fid,[   '%%%% MESRCBEGIN\n%% One Comment Line Here Please\n%%\n%% Tags: NOTAG\n%%\n',...
                    '%%\n',regexprep(MESRV_REV('${REV(1.0)}'),'%','%%'),'\n',...
                    '%%\n',...
                    '%%%% FUNCHANDLEBEGIN\n',...
                    '%% wenn FUNCHANDLEBEGIN und FUNCHANDLEBEND auerhalb sind dann knnen funktionen aufgerufen werden\n',...
                    '%% die variablen $VAR1$ usw. werden dann durch den text welche die funktionhalde liefern ersetzt.\n',...
                    '%%$VAR1$ ${@()inputdlg(''Aussagekrftiger Text1'')}\n',...
                    '%%$VAR_2$ ${@()inputdlg(''Aussagekrftiger Text2'')}\n',...
                    '%%%% FUNCHANDLEBEND\n',...
                    '%%%% MESRCEND\n%%%% ${H1} berschrift 1\n%% ${DATE}, ${AUTHORSHORT}\n'...
                ]);
    
    fclose(fid);
    edit(f.getLink)
    
function popupmenu_category_Callback(hObject, eventdata, handles)
strs = get(hObject,'String');
expr = strs{get(hObject,'Value')};

expr_ = ['((?<=,\s*)',expr,'|(?<!.)',expr,')'];
if strcmpi(expr,'Alles')
    handles.catIdx = true(size(handles.catIdx));
else
    handles.catIdx = util.regexCell(handles.tags,expr_);
end
fillTable(handles,false);

%% Create Functions
function pushbutton_edit_CreateFcn(hObject, eventdata, handles)
    if isDAUser >= enumDA.DAUserType.daDeveloper;
        set(hObject,'enable','on');
    end

function pushbutton_new_CreateFcn(hObject, eventdata, handles)
    if isDAUser >= enumDA.DAUserType.daDeveloper;
        set(hObject,'enable','on');
    end


