function newText = Matlab_extendEditorFunctionality_StringReplacements(action,aE)
if strcmpi(action,'CopyBlockHelper')
    createBlockHelper(aE);
    return
end

nl = sprintf('\n');
repPath = getappdata(0,'fileExchangeJustin_repPath');
oCD = cd(repPath);
dirCont = dir('*.m');

t = regexp(action,'(?<command>\w+)(?<variables>\([\w\.,]+\))?','names');

mFile = dirCont(arrayfun(@(x) ~isempty(regexpi(x.name,['^MESRC_',t.command,'.m$'],'once')),dirCont));
if isempty(mFile)
    newText = action;
else
    path = [repPath,'\',mFile.name];
    newText = readMFile_repaired(path,t);
end
cd(oCD);

% bei regulre ausdrcke die im Ersetz-Script vorkommen darf das nicht angewendet werden.
% wies ich das hier hin getan habe wei ich nicht mehr % 2014-06-11, aj
% newText = regexprep(newText,'\\','\\\\');
% newText = regexprep(newText,'\$','\\$');

function createBlockHelper(aE)
    aE.selection;
    txt = aE.mEditor.SelectedText;

    txt = regexprep(txt,'''',''''''); % ein ' durch '' ersetzen
    txt = regexprep(txt,'\$','\\$');
    txt = regexprep(txt,'\\','\\\\');
    txt = regexprep(txt,'([^\n]+)','\t''$1''') ;
    txt = regexprep(txt,'(?<!\n)\n',',nl,...\n');
    txt = regexprep(txt,'(?<=\n)\n','\t'''',nl,...\n');

    nl = sprintf('\n');
    txt = ['newText = [',nl,txt,nl,'];'];

    clipboard('copy',txt);

function txt = readMFile_repaired(path,tokens)
    jFile = java.io.File(path);
    jScanner = java.util.Scanner(jFile);
    jScanner.useDelimiter('\n');

    txt = '';
    while jScanner.hasNext
        txt = sprintf('%s',txt, char(jScanner.next));
    end
    jScanner.close();
    
    [idxS, idxE] = regexp(txt,'(%%\s+MESRCBEGIN|%%\s+MESRCEND\s*)','start','end');
    if ~isempty(idxS)
        txt(idxS(1):idxE(2)) = '';
        txt = regexprep(txt,'(%%\s+\\MESRCBEGIN|%%\s+\\MESRCEND)','${regexprep($1,''\\'','''')}');
    end
    txt = replaceFCNHandle(txt);
    
    txt = repaierStringVariables(txt,tokens);
    txt = replaceStringVariables(txt);
 
function txt = repaierStringVariables(txt,tokens)
    rep = ['\$\{',upper(tokens.command),tokens.variables,'}'];
    txt = regexprep(txt,['\$\{',upper(tokens.command),'}'],rep);
    
function txt = replaceStringVariables(txt)
    repPath = getappdata(0,'fileExchangeJustin_varPath');
    oCD = cd(repPath);
    dirCont = dir('*.m');

    mFile = dirCont(arrayfun(@(x) ~isempty(regexpi(x.name,'^MESRV_.+?\.m$','once')),dirCont));
    cd(oCD);
    
    for ii = 1:numel(mFile)
        com = mFile(ii).name;
        com = regexprep(com,'\.m$','','once');
        
        fh = str2func(['@(txt)',com,'(txt)']);
        txt = fh(txt);
    end
    
function [txt] = replaceFCNHandle(txt)
    [idxS, idxE] = regexp(txt,'(%%\s+FUNCHANDLEBEGIN|%%\s+FUNCHANDLEBEND\s*)','start','end');
    if isempty(idxS); return; end
    fcnText = txt(idxS(1):idxE(2));
    if ~isempty(idxS)
        txt(idxS(1):idxE(2)) = '';
        txt = regexprep(txt,'(%%\s+FUNCHANDLEBEGIN|%%\s+FUNCHANDLEBEND\s*)','${regexprep($1,''\\'','''')}');
    end

    fcns = regexp(fcnText,'(?<=\$\{)[^\}]+(?=\})','match');
    vars = regexp(fcnText,'(?<=\$)[^\$^\{]+?(?=\$)','match');
    vars = vars(~cellfun('isempty',regexprep(vars,'\s*','')));
    
    [fcns,idx] = unique(fcns,'stable');
    vars = vars(idx);
    
    for ii = 1:numel(fcns)
        fcn = str2func(fcns{ii});
        var = fcn();
        if isempty(var); fprintf('\n FunctionHandle "%s" returned empty \n',func2str(fcn)); return; end 
        if iscell(var); var = var{1};    end       
        txt = regexprep(txt,['\$',vars{ii},'\$'],var);
    end

    
    
   
    
    
    