function txt = MESRV_REV(txt)
% Revision
%% EXAMPLES
%{

txt = '${REV(3.4)}'
text = MESRV_REV(txt)

% liefert folgende Ausgabe
%     text =
%     % V3.4 | 2014-06-16 | name1 name2      | Commentary
%     %

txt = '${REV}'
text = MESRV_REV(txt)
% liefert folgende Ausgabe
%     text =
%     % V#.# | 2014-06-16 | name1 name2      | Commentary
%     %

%}
%% VERSIONING
%             Author: Andreas Justin
%           Copyright
%      Creation date: 2014-06-11
%             Matlab: 8.3.0.532 (R2014a)
%  Required Products: -
%
%% REVISIONS
% V1.0 | 2014-06-12 | Andreas Justin      | Ersterstellung
% V1.1 | 2014-06-16 | M***** *******      | revision text kann versionsnummer enthalten
% 
% See also

expr = '\$\{(REV)\(?(\d*\.?\d*)\)?}';
m = regexp(txt,expr,'tokens','once');
if ~isempty(m) && ~isempty(m{1})
    refNum = '#.#';
    if ~isempty(m{2});    refNum = m{2};   end
    size17author = blanks(19);
    nameAuthor = DA_getPCUserName;
    size17author(1:numel(nameAuthor)) = nameAuthor;
    newText = sprintf('%% V%s | %s | %s | Commentary\n%%', refNum,datestr(now,'yyyy-mm-dd'),size17author);
    txt = regexprep(txt, expr, newText);
end
