function mFileReplaceTextWith(mE,expr,repStr)
% replaces in Matlab editor handle $expr with $repStr
%
% INVOKING: outputpara = mFileReplaceTextWith(inputpara)
%
% CATEGORY: Aid  D:\sds\tools\DA\MatlabM\Lastdatenanalyse\Aid
%
%% DESCRIPTION
% 
%
%% INPUT
%     mE ... Matlab editor Handle
%   expr ... regularexpression searchstring
%            '\DoComment' -> 
% repStr ... replace string
%
%% EXAMPLES
%{
 mE = matlab.desktop.editor.getActive;
 mE = matlab.desktop.editor.findOpenDocument('mFileReplaceTextWith');
%}
%% VERSIONING
%             Author: Andreas Justin
%             Matlab: 8.1.0.604 (R2013a)
%  Required Products: -
%
%% REVISIONS
% V1.0 | 2013-09-23 |    Andreas Justin | Ersterstellung
%
%
% See also 

%% --------------------------------------------------------------------------------------------
narginchk(3,3)

txt = mE.Text;
if ~isempty(regexp(repStr,'\\DoComment','once'))
    expr = '%dacomment%';
    if isempty(regexpi(txt,expr,'once'))
        expr = '\%dafunction\%';
        if isempty(regexpi(txt,expr,'once'))
            error('nothing found with expr: ''%s"''',expr)
        end
        func = regexp(mE.Filename,'(?<=\\)\w+(?=\.m)','match','once');
    else
        func = '';
    end
    repStr = newComment(func);
    repStr = sprintf(['%s',char(13)],repStr{:});
    repStr = regexprep(repStr,'\\','\\\\');
end
dE = daEditor.DaEditor(mE.Filename);

idx = dE.selection;
pos = dE.idx2pos(idx(3),idx(4));
expr = regexprep(expr,'([\(\)\.])','\\$1');
dE.regexRep(expr,repStr,true,pos-numel(expr),pos-1);

